#include <cstdio>
#include <queue>
using namespace std;

struct Pos {
	int x, y, f;
	double c;
	bool operator<(const Pos &p) const {return c > p.c;}
};

int gx, gy, f;
double g[101][101];
double best[101][101][201];

main() {
	int i, j, k, x, y, n, N, dx, dy;
	double c;
	Pos p, p2;

	for( cin >> N; N--; ) {
		cin >> gy >> gx >> f >> n;
		for( i = 1; i <= gy; i++ )
		for( j = 1; j <= gx; j++ )
			g[i][j] = 1e20;
		for( i = 0; i < n; i++ ) {
			cin >> y >> x >> c;
			g[y][x] <?= c;
		}
		if( f >= gy+gx ) {
			printf( "%.2lf\n", 0.0 );
			continue;
		}

		for( i = 1; i <= gy; i++ )
		for( j = 1; j <= gx; j++ )
		for( k = 0; k <= f; k++ )
			best[i][j][k] = 1e20;
		p.x = p.y = 1; p.f = f; p.c = 0.0;
		priority_queue<Pos> q;
		q.push(p);
		best[p.y][p.x][p.f] = p.c;
		while( !q.empty() ) {
			p = q.top(); q.pop();
			if( p.x == gx && p.y == gy ) break;
			if( p.c > best[p.y][p.x][p.f] ) continue;

			for( dx = -1; dx <= 1; dx++ )
			for( dy = -1; dy <= 1; dy++ )
			if( abs(dx)+abs(dy) <= 1 ) {
				p2 = p;
				p2.x += dx; p2.y += dy;
				if( dx == 0 && dy == 0 ) {	// staying still, refueling
					p2.f++;
					p2.c += g[p2.y][p2.x];
				} else {					// moving one square
					p2.f--;
				}
				if( p2.x < 1 || p2.x > gx ) continue;
				if( p2.y < 1 || p2.y > gy ) continue;
				if( p2.f < 0 || p2.f > f ) continue;
				if( p2.c >= best[p2.y][p2.x][p2.f] ) continue;
				q.push(p2);
				best[p2.y][p2.x][p2.f] = p2.c;
			}
		}

		if( p.x == gx && p.y == gy ) {
			printf( "%.2lf\n", best[gy][gx][0] );
		} else {
			printf( "Stranded on the shoulder\n" );
		}
	}
}



